version: '3.8'
services:
  gitlab:
    image: '{{ gitlab_image }}'
    restart: always
    hostname: '{{ hostname }}'
    domainname: '{{ domainname }}'
    dns: {{ dns_servers }}
    dns_search: {{ dns_search }}
    container_name: "{{ container_name }}"
    environment:
      GITLAB_OMNIBUS_CONFIG: |
        external_url '{{ external_url }}'
        registry_external_url '{{ registry_external_url }}'
        nginx['ssl_certificate'] = "{{ ssl_cert_path }}"
        nginx['ssl_certificate_key'] = "{{ ssl_key_path }}"
        registry_nginx['ssl_certificate'] = "{{ registry_ssl_cert_path }}"
        registry_nginx['ssl_certificate_key'] = "{{ registry_ssl_key_path }}"
        nginx['redirect_http_to_https'] = true
        registry_nginx['redirect_http_to_https'] = true
        letsencrypt['enable'] = false
        registry['enable'] = true
        gitlab_rails['registry_enabled'] = true
        gitlab_rails['registry_api_url'] = "{{ registry_api_url }}"
        gitlab_rails['registry_host'] = "{{ registry_host }}"
        gitlab_rails['registry_port'] = "443"
        gitlab_rails['gitlab_shell_ssh_port'] = 2222
        gitlab_rails['ldap_enabled'] = true
        gitlab_rails['prevent_ldap_sign_in'] = false
        gitlab_rails['ldap_servers'] = {
        'main' => {
          'label' => 'LDAP',
          'host' =>  '{{ ldap_host }}',
          'port' => 636,
          'uid' => 'sAMAccountName',
          'encryption' => 'simple_tls',
          'bind_dn' => '{{ bind_dn }}',
          'password' => "{{ bind_password }}",
          'verify_certificates' => true,
          'tls_options' => {
            'ca_file' => "{{ ldap_tls_ca_path }}",
            'cert' => '{{ ldap_gitlab_user_cert_content }}',
            'key' => '{{ ldap_gitlab_user_key_content }}'
          },
          'timeout' => 10,
          'active_directory' => true,
          'allow_username_or_email_login' => true,
          'block_auto_created_users' => false,
          'base' => '{{ ldap_base }}',
          'user_filter' => '{{ user_filter }}',
          'attributes' => {
            'username' => ['uid', 'userid', 'sAMAccountName'],
            'email' => ['mail', 'email', 'userPrincipalName'],
            'name' => 'cn',
            'first_name' => 'givenName',
            'last_name' => 'sn'
          }
        }
      }
    ports:
      - '80:80'
      - '443:443'
      - '2222:2222'
    volumes:
      - '/srv/gitlab/config:/etc/gitlab'
      - '/srv/gitlab/logs:/var/log/gitlab'
      - '/srv/gitlab/data:/var/opt/gitlab'